import xBaseJ.rmi.*;

import java.rmi.*;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;


public class ClientDBFRMICase extends TestCase
{

public ClientDBFRMICase(String name) {super(name);}

protected void setUp()
{

}


protected void tearDown()
{

}


public void testReadThrough()
{

  String name = "//localhost/"+DBFServerInterface.serviceName;
  try {


     DBFServerInterface dbfServer = (DBFServerInterface) java.rmi.Naming.lookup(name);
     DBFInterface dbfi =  dbfServer.connectToDBF("d:/xBaseJ/test/jug.dbf");
     int r = dbfi.getRecordCount();
     for (int i = 0; i < r; i++)
       {
           dbfi.read();
           System.out.println(i + " " + dbfi.getCurrentRecordNumber());
           System.out.println(dbfi.getField(2).getName() + " " + dbfi.getField(2).get());

	   }

  }
  catch (Exception e)
   {
   e.printStackTrace();
   }
}

public void testGoto()
{

  String name = "//localhost/"+DBFServerInterface.serviceName;
  try {


     DBFServerInterface dbfServer = (DBFServerInterface) java.rmi.Naming.lookup(name);
     DBFInterface dbfi =  dbfServer.connectToDBF("d:/xBaseJ/test/jug.dbf");
     int r = dbfi.getRecordCount();
     int f = dbfi.getFieldCount();
     String values[][] = new String[r][f];
     int positions[] = new int[r];

     for (int i = 0; i < r; i++)
       {
           dbfi.read();
           positions[i] = dbfi.getCurrentRecordNumber();
           for (int j = 0; j < f; j++)
              values[i][j] = dbfi.getField(j+1).get();
	   }
     for (int i = 0; i < r; i++)
       {
           dbfi.gotoRecord(positions[i]);
           for (int j = 0; j < f; j++)
             if (values[i][j].compareTo(dbfi.getField(j+1).get()) != 0)
                 fail("values not equal at " + i + " " + j);
	   }

  }
  catch (Exception e)
   {
   e.printStackTrace();
   }
}


public void testFind()
{

  String name = "//localhost/"+DBFServerInterface.serviceName;
  try {


     DBFServerInterface dbfServer = (DBFServerInterface) java.rmi.Naming.lookup(name);
     DBFInterface dbfi =  dbfServer.connectToDBF("d:/xBaseJ/test/jug.dbf");
     int r = dbfi.getRecordCount();
     int f = dbfi.getFieldCount();
     String values[] = new String[r];
     int positions[] = new int[r];

     for (int i = 0; i < r; i++)
       {
           dbfi.read();
           positions[i] = dbfi.getCurrentRecordNumber();
           values[i] = dbfi.getField(2).get();
	   }
	 dbfi.useTag("name");
     for (int i = 0; i < r; i++)
       {
           dbfi.find(values[i]);
           if (values[i].compareTo(dbfi.getField(2).get()) != 0)
                 fail("values not equal at " + values[i]);
           if (positions[i] != dbfi.getCurrentRecordNumber())
                 System.out.println("record numbers not equal at " + positions[i] + " " + dbfi.getCurrentRecordNumber() + " " + values[i] + " " + dbfi.getField(2).get());

	   }

  }
  catch (Exception e)
   {
   e.printStackTrace();
   }
}

public void testTopFind()
{

  String name = "//localhost/"+DBFServerInterface.serviceName;
  try {


     DBFServerInterface dbfServer = (DBFServerInterface) java.rmi.Naming.lookup(name);
     DBFInterface dbfi =  dbfServer.connectToDBF("d:/xBaseJ/test/jug.dbf");
     dbfi.useTag("name");
     int r = dbfi.getRecordCount();
     dbfi.startTop();
     for (int i = 0; i < r; i++)
       {
           dbfi.findNext();
           System.out.println(i + " " + dbfi.getCurrentRecordNumber());
           System.out.println(dbfi.getField(2).getName() + " " + dbfi.getField(2).get());

	   }

  }
  catch (Exception e)
   {
   e.printStackTrace();
   }
}

public void testBottomFind()
{

  String name = "//localhost/"+DBFServerInterface.serviceName;
  try {


     DBFServerInterface dbfServer = (DBFServerInterface) java.rmi.Naming.lookup(name);
     DBFInterface dbfi =  dbfServer.connectToDBF("d:/xBaseJ/test/jug.dbf");
     dbfi.useTag("name");
     int r = dbfi.getRecordCount();
     dbfi.startBottom();
     for (int i = 0; i < r; i++)
       {
           System.out.println(i + " " + dbfi.getCurrentRecordNumber());
           System.out.println(dbfi.getField(2).getName() + " " + dbfi.getField(2).get());
           dbfi.findPrev();

	   }

  }
  catch (Exception e)
   {
   e.printStackTrace();
   }
}


public static void main(String arg[])
{
	String[] testCaseName = {ClientDBFRMICase.class.getName()};
	junit.ui.TestRunner.main(testCaseName);
}
}